"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const tslib_1 = require("tslib");
const archiver_1 = (0, tslib_1.__importDefault)(require("archiver"));
const fs = (0, tslib_1.__importStar)(require("fs-extra"));
const path_1 = (0, tslib_1.__importDefault)(require("path"));
async function genEpub(book) {
    const epubFile = fs.createWriteStream(path_1.default.join(config.dir, `${book.name}-${book.author}.epub`));
    const archive = (0, archiver_1.default)('zip', {
        zlib: { level: 9 },
    });
    archive.pipe(epubFile);
    archive.directory(path_1.default.join(config.dir, book.bid, 'OPS'), 'OPS');
    archive.directory(path_1.default.join(config.dir, book.bid, 'META-INF'), 'META-INF');
    archive.append(fs.createReadStream(path_1.default.join(config.dir, book.bid, 'mimetype')), { name: 'mimetype' });
    await archive.finalize();
}
exports.default = genEpub;
