"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const tslib_1 = require("tslib");
const cheerio = (0, tslib_1.__importStar)(require("cheerio"));
async function fetchBookInfo(bid, cover) {
    const { ajax } = globalThis;
    const bookUrl = `/book/${bid}/index.htm`;
    const res = await ajax.get(bookUrl);
    return _parse(bid, res.data, cover);
}
function _parse(bid, html, cover) {
    const $ = cheerio.load(html);
    const title = $('#dir');
    const logs = $('dd', title);
    const name = $('h2', html).text();
    let author = '';
    let catalogs = [];
    let chapters = [];
    $('a', $('h4', html).first()).each((_, ele) => {
        author += ele.children[0].data;
    });
    const coverSrc = cover || $('img', html).first().attr('src');
    logs.each((_, elem) => {
        catalogs.push(String($('a', elem).attr('href')));
        chapters.push(String($('a', elem).text()));
    });
    if (_isEmpty(name) ||
        _isEmpty(author) ||
        _isEmpty(coverSrc) ||
        catalogs.length === 0) {
        return null;
    }
    else {
        return {
            bid,
            name: name,
            author: author,
            cover: !coverSrc.includes('http') ? 'https:' + coverSrc : coverSrc,
            catalogs: catalogs,
            chapters: chapters,
        };
    }
}
function _isEmpty(str) {
    if (str) {
        return str.length === 0;
    }
    else {
        return true;
    }
}
exports.default = fetchBookInfo;
