"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const tslib_1 = require("tslib");
const cheerio = (0, tslib_1.__importStar)(require("cheerio"));
const const_1 = require("./const");
let client, box, star, epub;
const base64 = {
    map: 'ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/',
    decode: function (a) {
        var b = (d = '');
        for (var i = 0; i < a.length; i++) {
            if (a.substr(i, 1) == '=') {
                break;
            }
            var c = this.map.indexOf(a.charAt(i)).toString(2);
            d +=
                { 1: '00000', 2: '0000', 3: '000', 4: '00', 5: '0', 6: '' }[c.length] +
                    c;
        }
        var d = d.match(/[0-1]{8}/g);
        for (var i = 0; i < d.length; i++) {
            b += String.fromCharCode(parseInt(d[i], 2));
        }
        return b;
    },
};
function _load() {
    let nodes = [];
    var e = base64.decode(client).split(/[A-Z]+%/);
    var j = 0;
    for (var i = 0; i < e.length; i++) {
        const numTmp = parseInt(e[i]);
        if (numTmp < 3) {
            nodes[numTmp] = box
                .children()
                .eq(i + star)
                .text();
            j++;
        }
        else {
            nodes[numTmp - j] = box
                .children()
                .eq(i + star)
                .text();
            j = j + 2;
        }
    }
    let result = epub ? [] : '';
    for (var s = 0; s < nodes.length; s++) {
        epub ? result.push(nodes[s]) : nodes[s] + '\n';
    }
    return result;
}
function _init(a) {
    box = a;
    for (var i = 0; i < box.children().length; i++) {
        if (box.children()[i].name == 'h2') {
            star = i + 1;
        }
        if (box.children()[i].name == 'DIV' &&
            box.children()[i].attribs.class != 'chapter') {
            break;
        }
    }
    return _load();
}
function decode(html, isEpub = false) {
    var $ = cheerio.load(html, { decodeEntities: false });
    const key = $('meta[name=client]').attr('content');
    client = key;
    epub = isEpub;
    const content = $('#content');
    const title = $('h2').text();
    $ = cheerio.load('<div id="content">' + content.html() + '</div>');
    $('abbr,bdi,command,footer,keygen,mark,strike,acronym,bdo,big,site,code,dfn,kbd,q,s,samp,tt,u,var,cite,details,figure').remove();
    const contentString = _init($('#content'));
    return !epub
        ? `${title}\n\n${contentString}`
        : (0, const_1.getHtml)(title, contentString);
}
exports.default = decode;
