"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const tslib_1 = require("tslib");
const fs = (0, tslib_1.__importStar)(require("fs-extra"));
const path_1 = (0, tslib_1.__importDefault)(require("path"));
const const_1 = require("./const");
const decode_1 = (0, tslib_1.__importDefault)(require("./decode"));
async function writeEpub(book, task) {
    // 写出 package.opf
    _writeFile(path_1.default.join(config.dir, book.bid, 'OPS', 'package.opf'), (0, const_1.getPackageOpf)(book));
    // 写出 nav
    _writeFile(path_1.default.join(config.dir, book.bid, 'OPS', 'nav.xhtml'), (0, const_1.getNav)(book));
    // 写出 style
    _writeFile(path_1.default.join(config.dir, book.bid, 'OPS', 'css', 'style.css'), (0, const_1.getStyle)());
    // 写出 container
    _writeFile(path_1.default.join(config.dir, book.bid, 'META-INF', 'container.xml'), (0, const_1.getContainer)());
    // 写出 chapters
    await _writeChapters(book, task);
}
async function _writeChapters(book, task) {
    for (let i = 0; i < book.catalogs.length; i++) {
        const chapter = book.catalogs[i];
        const res = await ajax.get(chapter);
        const arr = chapter.split('/');
        const fileName = arr[arr.length - 1].replace('.htm', '.xhtml');
        const filePath = path_1.default.join(config.dir, book.bid, 'OPS', 'xhtml', fileName);
        _writeFile(filePath, (0, decode_1.default)(res.data, true));
        task.title = `写出文件\t${i + 1}/${book.catalogs.length}`;
    }
}
function _writeFile(path, content) {
    fs.createFileSync(path);
    fs.writeFileSync(path, content);
}
exports.default = writeEpub;
